
/* Scenesort.rexx - sorts Lightwave scene files into hierarchical order
   written BY Alistair Buxton */

obpos = 0
totlines = 0
name.obpos = "None"
PARSE ARG infile outfile verb
verb = Strip(verb, "B")
IF verb ~= "-v" THEN verb = 0
IF verb = "-v" THEN verb = 1

outfile = Strip(outfile, "B")
IF infile = "?" THEN DO
   SAY "Scenesort - Alistair Buxton, email ali@ajaybee.demon.co.uk"
   SAY ""
   SAY "Usage = rx scenesort.rexx <sourcefile> <dest. file> [-v]"
   SAY "-v turns on verbose mode, THIS WILL SLOW IT DOWN ALOT."
   EXIT
END
Open("infile", infile)
DO WHILE ~Eof("infile")
   curline = ReadLn("infile")
   totlines = totlines + 1
   PARSE VAR curline command rest
   IF command = "LoadObject" | command = "AddNullObject" THEN DO
      rest = Strip(rest, "B")
      obpos = obpos + 1
      name.obpos = rest
      startln.obpos = totlines
      parent.obpos = 0
      sort.obpos = 0
      cline = ReadLn("infile")
      totlines = totlines + 1
      DO WHILE cline ~= ""
         PARSE VAR cline command rest
         rest = Strip(rest, "B")
         IF command = "ParentObject" THEN parent.obpos = rest
         cline = ReadLn("infile")
         totlines = totlines + 1
      END
   END
END
IF verb THEN SAY "Total lines in file: "||totlines
DO cur = 1 TO obpos BY 1
   ch.cur = ""
   num = 0
   level.cur = 0
   here = cur
   DO che = 1 TO obpos BY 1
      IF parent.che = cur THEN DO
         num = num + 1
         ch.num.cur = che
      END
   numch.cur = num
   END
   DO WHILE parent.here ~=0
      level.cur = level.cur + 1
      here = parent.here
   END
END
neworder = ""
DO find = 1 TO obpos BY 1
   IF level.find = 0 THEN neworder = neworder||Right(find, 3, "0")||" "
END
DO abc = 1 TO obpos BY 1
   cur = Strip(Word(neworder, abc), "L", "0")
   DO add = 1 TO numch.cur BY 1
      nameo = ch.add.cur
      addpos = ( ( abc + add ) - 1 ) * 4
      neworder = Insert((Strip(Right(ch.add.cur, 3, "0"), "B")||" "), neworder, addpos)
   END
END
IF verb THEN SAY "New order will be:"
DO out = 1 TO obpos BY 1
   flibble = Strip(Word(neworder, out), "L", "0")
   order.out = flibble
   revord.flibble = out
   IF verb THEN SAY name.flibble
END
Open("outfile", outfile, write)
Seek("infile", 0, B)
DO firstbit = 1 TO 7 BY 1
   write = ReadLn("infile")
   WriteLn("outfile", write)
END
DO sorter = 1 TO obpos BY 1
   Seek("infile", 0, B)
   nextobj = order.sorter
   DO skip = 1 TO ( startln.nextobj - 1 ) BY 1
      trash = ReadLn("infile")
   END
   write = ReadLn("infile")
   WriteLn("outfile", write)
   DO WHILE write ~= ""
      write = ReadLn("infile")
      PARSE VAR write command rest
      IF command = "ParentObject" THEN DO
         woo = parent.nextobj
         write = "ParentObject "||revord.woo
         IF verb THEN SAY "Line "||command||rest||" replaced by "||write
      END
      WriteLn("outfile", write)
      if verb then say write||" written to file"
   END
END
Seek("infile", 0, B)
DO skip = 1 TO startln.obpos BY 1
   trash = ReadLn("infile")
END
write = ReadLn("infile")
DO WHILE write ~= ""
   write = ReadLn("infile")
END
DO WHILE ~Eof("infile")
   write = ReadLn("infile")
   WriteLn("outfile", write)
END
Close("infile")
Close("outfile")

SAY "Operation successful"
