/* DiskNote.rexx
   Puts a filenote on a file, consisting of the two first lines
   in the file, separated by ": ". This has the effect - for
   Disk Files for e.g. OptyCDPlayer - of making the author and
   title visible in a directory listing or utility.
   Niels Bache, 14/7-96.
*/

parse arg File .
File = strip(File, 'B', '"')

if length(File) <= 0 then do
   say "No file name given!"
   exit 10
end

if ~open('In', File, 'R') then do
   say "File not found!"
   exit 10
end

if eof('In') then do
   say "File empty!"
   exit 10
end

Line1 = readln('In')
if length(Line1) <= 0 then do
   say "No author found in file!"
   exit 10
end

if eof('In') then do
   say "File too short!"
   exit 10
end

Line2 = readln('In')
if length(Line2) <= 0 then do
   say "No title found in file!"
   exit 10
end

if eof('In') then do
   say "File too short!"
   exit 10
end

call close('In')

Note = Line1 || ": " || Line2
if Length(Note) > 79 then do
   Note = left(Note, 78) || ""
end

Note = '"' || Note || '"'
MyCmd = "filenote " || File || " " || Note
address command MyCmd
if RC ~= 0 then do
   say "Error (RC = " || RC || ") while setting file note!"
   exit 10
end

exit 0
