/* MailTo-YAM.VRX by Michel 'Bitstorm' Labb <mlabbe@quebectel.com>
** $VER: MailTo-YAM v1.06 (29.04.96)
**
** This is a very simple script designed for use with Voyager's new mailto:
** support.
**
** Thanks to Mike Fitzgerald for the original script
** Credits also goes to: DFDuck for helping me with ARexx programming
**                       Phideaux for early betatesting
**                       Olli for writing very nice softwares such as V
**
** Set Voyager's mailto: string as follow
** mailto: App [RX Rexx/MailTo-YAM.VRX "%h"]
**
** Now change the variables below to whatever fits for your setup.
**
** Notes: YAM must be running for the script to work
**        To pop CED on V's Pubscreen, you need the GetPubScreen command
**
**
** Known bug(s):
** The script won't send the mail if YAM wasn't already running when you
** started the script and you have "Get mail on startup" turned on.  To
** fix this, turn off that flag in YAM's configs.
**
*/

AddSignature = 'Yes'					/* use YAM's signature		*/
PopOnVScreen = 'Yes'					/* pop CED on V's pubscreen	*/
Editor       = 'CED'					/* path/name of the editor	*/
Subject      = 'Message from your URL'	/* subject for the message	*/
YAMPath      = 'YAM:'					/* must end with : or /		*/

parse arg mailto

/* check for the presence of Libs:rexxsupport.library */

if ~show('L','rexxsupport.library') then do
	if addlib('rexxsupport.library',0,-30,0) then nop
	else do
		call showerror('This script needs the rexxsupport.library to work properly.  This file can be found on your original Workbench 2+ disks and should be placed in Libs:')
		exit 20
	end
end
	
/* add YAM's signature if YAM:.signature file exists */

if(upper(AddSignature) = 'YES') then do
	if exists(YAMPath'.signature') then
		shell command 'copy 'YAMPath'.signature t:mail'
	else
		do	call showerror('No signature file found! Please correct this in YAM or turn off signature adding in MailTo-YAM.VRX<BR>You should also check the YAMPath in MailTo-YAM.VRX')
			exit 20
		end
end


/* send the mail from YAM */

call pragma('stack',10000)

if upper(PopOnVScreen) = 'YES' then
	address command (editor' -keepio -pubscreen=`getpubscreen` t:mail')
else address command (editor' -keepio t:mail')

/* look for YAM process */
if ~show('P','YAM') then do
	shell command 'Run <>NIL: YAM:YAM'
	do until show('P','YAM')
		call delay(50)  /* needs rexxsupport.library */
	end
end

address YAM
WriteMailTo mailto
'WriteSubject "'Subject'"'
WriteLetter 'T:Mail'
WriteQueue
MailSendAll
call delete('t:mail')  (rexxsupport.library)

EXIT

/* sophisticated errorhandling (ripped from MailTo-THOR.VRX) :-) */

showerror:
	parse arg errormsg

	p=show('P',,)
	if(pos('MINDWALKER', p) > 0) then vport = word(substr(p, pos('MINDWALKER', p)), 1)
	else return

	call open(err, "T:MailTo-YAM.error.html", W)
	call writeln(err, "<HTML><HEAD><TITLE>MailTo-YAM.VRX encountered an error</TITLE></HEAD><BODY><H1>Sending mail aborted</H1>" || errormsg || ".")
	call close(err)

	address(vport)
	'openURL file://localhost/T:MailTo-YAM.error.html'

	return
